/// <reference types="node" />
import * as Kafka from 'node-rdkafka';
import { PubSubEngine } from 'graphql-subscriptions';
import * as Logger from 'bunyan';
export interface IKafkaOptions {
    topic: string;
    host: string;
    port: string;
    logger?: Logger;
    groupId?: any;
    globalConfig?: object;
    topicConfig?: object;
    useHeaders?: boolean;
    keyFun?: (any: any) => Buffer;
}
export declare class KafkaPubSub extends PubSubEngine {
    protected producer: Kafka.HighLevelProducer;
    protected consumer: Kafka.KafkaConsumer;
    protected options: any;
    private ee;
    private subscriptions;
    private subIdCounter;
    protected logger: Logger;
    constructor(options: IKafkaOptions);
    publish(channel: string, payload: any): Promise<void>;
    subscribe(channel: string, onMessage: (...args: any[]) => void, options?: Object): Promise<number>;
    unsubscribe(index: number): void;
    close(): Promise<void>;
    brokerList(): any;
    private serialiseMessage;
    private deserialiseMessage;
    private createProducer;
    private createConsumer;
}
