"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Kafka = require("node-rdkafka");
var graphql_subscriptions_1 = require("graphql-subscriptions");
var Logger = require("bunyan");
var child_logger_1 = require("./child-logger");
var uuid_1 = require("uuid");
var events_1 = require("events");
var defaultLogger = Logger.createLogger({
    name: 'pubsub',
    stream: process.stdout,
    level: 'info'
});
var KafkaPubSub = (function (_super) {
    __extends(KafkaPubSub, _super);
    function KafkaPubSub(options) {
        var _this = _super.call(this) || this;
        _this.options = options;
        _this.logger = child_logger_1.createChildLogger(_this.options.logger || defaultLogger, 'KafkaPubSub');
        _this.ee = new events_1.EventEmitter();
        _this.subscriptions = {};
        _this.subIdCounter = 0;
        return _this;
    }
    KafkaPubSub.prototype.publish = function (channel, payload) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, kafkaPayload;
            var _this = this;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = this;
                        _b = this.producer;
                        if (_b) return [3, 2];
                        return [4, this.createProducer()];
                    case 1:
                        _b = (_c.sent());
                        _c.label = 2;
                    case 2:
                        _a.producer = _b;
                        kafkaPayload = payload;
                        if (!this.options.useHeaders) {
                            kafkaPayload = {
                                channel: channel,
                                payload: payload
                            };
                        }
                        if (this.logger.debug) {
                            this.logger.debug("Publish %s", JSON.stringify(kafkaPayload));
                        }
                        return [2, new Promise(function (resolve, reject) {
                                _this.producer.produce(_this.options.topic, null, _this.serialiseMessage(kafkaPayload), _this.options.keyFun ? _this.options.keyFun(kafkaPayload) : null, Date.now(), _this.options.useHeaders ? [{ channel: Buffer.from(channel) }] : null, function (err) {
                                    if (err) {
                                        reject(err);
                                    }
                                    else {
                                        resolve();
                                    }
                                });
                            })];
                }
            });
        });
    };
    KafkaPubSub.prototype.subscribe = function (channel, onMessage, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, internalMessage;
            var _this = this;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        this.logger.info("Subscribing to %s", channel);
                        _a = this;
                        _b = this.consumer;
                        if (_b) return [3, 2];
                        return [4, this.createConsumer(this.options.topic)];
                    case 1:
                        _b = (_c.sent());
                        _c.label = 2;
                    case 2:
                        _a.consumer = _b;
                        internalMessage = function () {
                            var args = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                args[_i] = arguments[_i];
                            }
                            if (_this.options.useHeaders) {
                                onMessage(_this.deserialiseMessage(args[0]));
                            }
                            else {
                                onMessage.apply(void 0, args);
                            }
                        };
                        this.ee.addListener(channel, internalMessage);
                        this.subIdCounter = this.subIdCounter + 1;
                        this.subscriptions[this.subIdCounter] = [channel, internalMessage];
                        return [2, Promise.resolve(this.subIdCounter)];
                }
            });
        });
    };
    KafkaPubSub.prototype.unsubscribe = function (index) {
        var _a = this.subscriptions[index], channel = _a[0], onMessage = _a[1];
        this.logger.info("Unsubscribing from %s", channel);
        delete this.subscriptions[index];
        this.ee.removeListener(channel, onMessage);
    };
    KafkaPubSub.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            var producerPromise, consumerPromise;
            var _this = this;
            return __generator(this, function (_a) {
                producerPromise = new Promise(function (resolve, reject) {
                    if (_this.producer) {
                        _this.producer.disconnect(function (err) {
                            if (err) {
                                reject(err);
                            }
                            else {
                                resolve();
                            }
                        });
                    }
                });
                consumerPromise = new Promise(function (resolve, reject) {
                    if (_this.consumer) {
                        _this.consumer.disconnect(function (err) {
                            if (err) {
                                reject(err);
                            }
                            else {
                                resolve();
                            }
                        });
                    }
                });
                return [2, Promise.all([producerPromise, consumerPromise]).then()];
            });
        });
    };
    KafkaPubSub.prototype.brokerList = function () {
        return this.options.port ? this.options.host + ":" + this.options.port : this.options.host;
    };
    KafkaPubSub.prototype.serialiseMessage = function (message) {
        return Buffer.from(JSON.stringify(message));
    };
    KafkaPubSub.prototype.deserialiseMessage = function (message) {
        return JSON.parse(message.toString());
    };
    KafkaPubSub.prototype.createProducer = function () {
        return __awaiter(this, void 0, void 0, function () {
            var producer;
            var _this = this;
            return __generator(this, function (_a) {
                producer = new Kafka.HighLevelProducer(Object.assign({}, {
                    'metadata.broker.list': this.brokerList(),
                }, this.options.globalConfig), Object.assign({}, {}, this.options.topicConfig));
                producer.on('event.error', function (err) {
                    _this.logger.error(err);
                });
                return [2, new Promise(function (resolve, reject) {
                        producer.on('ready', function (data, metadata) {
                            var topics = metadata.topics.map(function (topic) { return topic.name; });
                            _this.logger.info('Connected, found topics: %s', topics);
                            if (topics.includes(_this.options.topic)) {
                                resolve(producer);
                            }
                            else {
                                _this.logger.error('Could not find requested topic %s', _this.options.topic);
                                producer.disconnect();
                                reject('Could not find requested topic %s');
                            }
                        });
                        _this.logger.info("Connecting producer ...");
                        producer.connect();
                    })];
            });
        });
    };
    KafkaPubSub.prototype.createConsumer = function (topic) {
        return __awaiter(this, void 0, void 0, function () {
            var groupId, consumer;
            var _this = this;
            return __generator(this, function (_a) {
                groupId = this.options.groupId || uuid_1.v4();
                consumer = new Kafka.KafkaConsumer(Object.assign({}, {
                    'group.id': "kafka-pubsub-" + groupId,
                    'metadata.broker.list': this.brokerList()
                }, this.options.globalConfig), Object.assign({}, { "auto.offset.reset": "latest" }, this.options.topicConfig));
                consumer.on('data', function (message) {
                    if (_this.logger.debug) {
                        _this.logger.debug("Received %s", message.value.toString());
                    }
                    if (_this.options.useHeaders && message.headers) {
                        var channelHeader = message.headers.find(function (header) { return "channel" in header; });
                        if (channelHeader) {
                            var channel = channelHeader.channel.toString();
                            _this.ee.emit(channel, message.value);
                        }
                        else {
                            _this.logger.warn("Missing 'channel' header");
                        }
                    }
                    else {
                        var parsedMessage = _this.deserialiseMessage(message.value);
                        if (parsedMessage.channel) {
                            _this.ee.emit(parsedMessage.channel, parsedMessage.payload);
                        }
                        else {
                            _this.ee.emit(topic, parsedMessage);
                        }
                    }
                });
                consumer.on('event.log', function (event) {
                    _this.logger.debug(event);
                });
                return [2, new Promise(function (resolve, reject) {
                        consumer.on('ready', function (data, metadata) {
                            var topics = metadata.topics.map(function (topic) { return topic.name; });
                            _this.logger.info('Connected, found topics: %s', topics);
                            if (topics.includes(topic)) {
                                _this.logger.info("Subscribing to %s", topic);
                                consumer.subscribe([topic]);
                                consumer.consume();
                                resolve(consumer);
                            }
                            else {
                                _this.logger.error('Could not find requested topic %s', topic);
                                consumer.disconnect();
                                reject('Could not find requested topic %s');
                            }
                        });
                        _this.logger.info("Connecting consumer ...");
                        consumer.connect();
                    })];
            });
        });
    };
    return KafkaPubSub;
}(graphql_subscriptions_1.PubSubEngine));
exports.KafkaPubSub = KafkaPubSub;
//# sourceMappingURL=kafka-pubsub.js.map