"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
require("dotenv").config();
var index_1 = require("../index");
var Logger = require("bunyan");
var pubsub;
beforeAll(function () {
    jest.setTimeout(60000);
    pubsub = new index_1.KafkaPubSub({
        topic: process.env.KAFKA_TOPIC || 'test',
        host: process.env.KAFKA_HOST || 'localhost',
        port: process.env.KAFKA_PORT || '9092',
        logger: Logger.createLogger({
            name: 'pubsub',
            stream: process.stdout,
            level: 'info'
        }),
        useHeaders: false,
        globalConfig: {
            'security.protocol': process.env.KAFKA_SECURITY || 'PLAINTEXT',
        }
    });
});
afterAll(function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, pubsub.close()];
            case 1:
                _a.sent();
                return [2];
        }
    });
}); });
describe('KafkaPubSub Basic Tests', function () {
    test('should subscribe and publish messages correctly', function (done) { return __awaiter(void 0, void 0, void 0, function () {
        function onMessage(payload) {
            try {
                expect(payload).toStrictEqual(inputPayload);
                done();
            }
            catch (error) {
                done(error);
            }
        }
        var inputChannel, inputPayload, subscription;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    inputChannel = 'test-subscribe';
                    inputPayload = {
                        id: 'subscribe-value',
                    };
                    return [4, pubsub.subscribe(inputChannel, onMessage)];
                case 1:
                    subscription = _a.sent();
                    return [4, new Promise(function (r) { return setTimeout(r, 5000); })];
                case 2:
                    _a.sent();
                    return [4, pubsub.publish(inputChannel, inputPayload)];
                case 3:
                    _a.sent();
                    return [2];
            }
        });
    }); });
    test('should subscribe correctly using asyncIterator', function () { return __awaiter(void 0, void 0, void 0, function () {
        var inputChannel, iter, i, rep, inputPayload, promise, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    inputChannel = 'test-iterator';
                    iter = pubsub.asyncIterator(inputChannel);
                    return [4, new Promise(function (r) { return setTimeout(r, 5000); })];
                case 1:
                    _b.sent();
                    rep = 10;
                    i = 0;
                    _b.label = 2;
                case 2:
                    if (!(i < rep)) return [3, 7];
                    inputPayload = { id: "iter-" + i };
                    promise = iter.next();
                    return [4, pubsub.publish(inputChannel, inputPayload)];
                case 3:
                    _b.sent();
                    _a = expect;
                    return [4, promise];
                case 4: return [4, (_b.sent()).value];
                case 5:
                    _a.apply(void 0, [_b.sent()]).toStrictEqual({ id: "iter-" + i });
                    _b.label = 6;
                case 6:
                    i++;
                    return [3, 2];
                case 7: return [4, iter.return()];
                case 8:
                    _b.sent();
                    return [2];
            }
        });
    }); });
});
//# sourceMappingURL=kafka-pubsub.spec.js.map